const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const messages = sequelize.define(
    'messages',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

subject: {
        type: DataTypes.TEXT,
      
      

      },

body: {
        type: DataTypes.TEXT,
      
      

      },

status: {
        type: DataTypes.ENUM,
      
      

        values: [

"unread",


"read",


"archived",


"blocked"

        ],

      },

sent_at: {
        type: DataTypes.DATE,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  messages.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity




































//end loop



    db.messages.belongsTo(db.private_mailboxes, {
      as: 'mailbox',
      foreignKey: {
        name: 'mailboxId',
      },
      constraints: false,
    });

    db.messages.belongsTo(db.users, {
      as: 'from_user',
      foreignKey: {
        name: 'from_userId',
      },
      constraints: false,
    });

    db.messages.belongsTo(db.organizations, {
      as: 'organizations',
      foreignKey: {
        name: 'organizationsId',
      },
      constraints: false,
    });



    db.messages.hasMany(db.file, {
      as: 'attachment_files',
      foreignKey: 'belongsToId',
      constraints: false,
      scope: {
        belongsTo: db.messages.getTableName(),
        belongsToColumn: 'attachment_files',
      },
    });


    db.messages.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.messages.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return messages;
};


